///////////////////////////////////////////////////////////////////////////////
//ǽCSV եʸʬ򤹤롣
//⡧Windows,UNIX ǥͭ
//Copyright (C) 2001-2002 Takashi Sugiyama. All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
#include "TSCSV.h"
#include <string.h> //memset()
#include <stdlib.h> //calloc()
#include <malloc.h> //calloc()

#ifdef WIN32
	#include <mbstring.h>
	#define MBSSTR(s1,s2) _mbsstr(s1,s2)
	#define ISMBSLEAD(s1,s2) _ismbslead(s1,s2)
#else //UNIX
	#include "TSMBS.h"
	#define MBSSTR(s1,s2) TSC_mbsstr(s1,s2)
	#define ISMBSLEAD(s1,s2) TSC_ismbslead(s1,s2)

	#define CONST const
	#define FALSE 0
	#define TRUE 1
	typedef void VOID;
	typedef int BOOL;
	typedef int INT;
	typedef long LONG;
	typedef unsigned long DWORD;
	typedef unsigned char* LPBYTE;
	typedef char* LPTSTR;
	typedef const char* LPCTSTR;
#endif

#define ERRNO_4101 4101 //calloc()
						//
#define ERRNO_4102 4102 //פ٤ʸ
						//V1.1.0 
#define ERRNO_4103 4103 //IDĤʤ
						//V1.0.0 
#define ERRNO_4104 4104 //եɤĤʤ
						//V1.0.0 
#define ERRNO_4105 4105 //ѥ᡼ NULL ݥ󥿤
						//V1.0.0 
//#define ERRNO_4106 4106 //ʾǤʤФʤʤͤ
						//V1.0.0 V1.1.0 
#define ERRNO_4107 4107 //ѥ᡼ NULL ݥ󥿤
						//V1.0.0 
//#define ERRNO_4108 4108 //ʾǤʤФʤʤͤ
						//V1.0.0 V1.1.0 
#define ERRNO_4109 4109 //ѥ᡼ NULL ݥ󥿤
						//V1.0.0 
#define ERRNO_4110 4110 //ХåեƳǼǤʤ
						//V1.0.0 
#define ERRNO_4111 4111 //ѥ᡼ NULL ݥ󥿤
						//V1.0.0 
#define ERRNO_4112 4112 //ǥߥ˶ʸϻǤʤ
						//V1.0.0 
//#define ERRNO_4113 4113 //ѥ᡼ NULL ݥ󥿤
						//V1.0.0 V1.1.0 
#define ERRNO_4114 4114 //ѥ᡼ NULL ݥ󥿤
						//V1.0.0 
#define ERRNO_4115 4115 //ХåեƳǼǤʤ
						//V1.1.0 
#define ERRNO_4116 4116 //ǼХåեǡ⾮
						//V1.1.0 
#define ERRNO_4117 4117 //ǼХåեƳǼǤʤ
						//V1.1.0 
#define ERRNO_4118 4118 //ǼХåեƳǼǤʤ
						//V1.1.0 
#define ERRNO_4119 4119 //TSCSV_GetFieldAsString() ιԴʼԤˤޤǽ
						//V1.4.0 

#define TSCSV_MUTEX "Mutex of TSCSV"

struct ID_INFO //ID
{
	INT iID; //ID
	LPTSTR pszDlmt; //ǥߥ
	LPTSTR pszQuot; //եɤγ국
	LPTSTR pszEsc; //ʸ
	INT iErrNo;
	DWORD dwOpt; //ץ
	struct ID_INFO *ps_IDNext; //ι¤ΤؤΥݥ
};

static BOOL mbInit = FALSE; //=TRUE:Ѥ
static INT miErrNo = 0;
static struct ID_INFO ms_IDTop; //Ƭ

///////////////////////////////////////////////////////////////////////////////
//ǽID˳ID_INFO롣
//ֵ͡!=0:ID_INFOΥݥ  =0:IDĤʤ
//СV1.0.0 2001/11/01 
//          V1.3.0 2001/12/30 
//                   ¾档
///////////////////////////////////////////////////////////////////////////////
static struct ID_INFO *GetIDInfo(
CONST INT iID, //(I)ID >0
struct ID_INFO **pps_IDPrev //(O)ID_INFOľID_INFO
)
{
	struct ID_INFO *ps_IDTmp = NULL, *ps_IDPrev = NULL;
#ifdef WIN32
	HANDLE hMtx = CreateMutex( NULL, FALSE, TSCSV_MUTEX );
	WaitForSingleObject( hMtx, INFINITE ); //å
#endif //WIN32
	ps_IDTmp = ms_IDTop.ps_IDNext; //IDõ
	ps_IDPrev = &ms_IDTop;
	while ( ps_IDTmp )
	{
		if ( ps_IDTmp->iID == iID ) //IDפ
			break;
		ps_IDPrev = ps_IDTmp; //ҤȤȤ¸
		ps_IDTmp = ps_IDTmp->ps_IDNext;
	}
	if ( pps_IDPrev )
		*pps_IDPrev = ps_IDPrev;
	if ( !ps_IDTmp )
		miErrNo = ERRNO_4103;
#ifdef WIN32
	ReleaseMutex( hMtx ); //ߥ塼ƥå
#endif //WIN32
	return ps_IDTmp;
}

///////////////////////////////////////////////////////////////////////////////
//ǽID롣
//ֵ͡>0:ID  <0:顼
//СV1.0.0 2001/11/01 
//          V1.2.0 2001/12/04 
//                   ץб
//          V1.3.0 2001/12/30 
//                   ¾б
//          V1.4.0 2002/01/15 
//                    TSCSV_Init() 
///////////////////////////////////////////////////////////////////////////////
/*extern "C"*/ INT WINAPI /*EXPORT*/ TSCSV_GetID()
{
	INT iMaxID = 0; //ȯԺѤIDκ
	struct ID_INFO *ps_IDNew = NULL, *ps_IDTmp = NULL;

#ifdef WIN32
	HANDLE hMtx = CreateMutex( NULL, FALSE, TSCSV_MUTEX );
	WaitForSingleObject( hMtx, INFINITE ); //å
#endif //WIN32
	if ( !mbInit ) //Ƥʤʤ
	{
// DLL θƤӽФȼ¹ԥեΥ󥹥ˣ¹Ԥ롣
//åˤϼ¹Ԥʤ
		memset( &ms_IDTop, 0, sizeof( ms_IDTop ));
		mbInit = TRUE; //Ѥߥե饰
	}
	ps_IDTmp = &ms_IDTop; //ǽݥ󥿤õ
	while ( ps_IDTmp->ps_IDNext )
	{
		ps_IDTmp = ps_IDTmp->ps_IDNext;
		if ( ps_IDTmp->iID > iMaxID ) //IDκͤõʤ
			iMaxID = ps_IDTmp->iID;
	}
	ps_IDNew = (struct ID_INFO*)calloc( 1, sizeof( struct ID_INFO ));
	if ( !ps_IDNew )
	{
		miErrNo = ERRNO_4101;
#ifdef WIN32
		ReleaseMutex( hMtx ); //ߥ塼ƥå
#endif //WIN32
		return -1;
	}
	ps_IDNew->iID = iMaxID+1; //ID򥻥å
	ps_IDNew->pszDlmt = strdup( "," ); //ǥեȤΥǥߥ
	ps_IDNew->pszQuot = strdup( "\"" ); //ǥեȤγʸ
	ps_IDNew->pszEsc = strdup( "\"" ); //ǥեȤΥʸ
	ps_IDNew->dwOpt = 0; //ץ
	ps_IDTmp->ps_IDNext = ps_IDNew; //κǸɲ
#ifdef WIN32
	ReleaseMutex( hMtx ); //ߥ塼ƥå
#endif //WIN32
	return ps_IDNew->iID;
}

///////////////////////////////////////////////////////////////////////////////
//ǽID롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2001/11/01 
//          V1.3.0 2001/12/30 
//                   ¾档
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_FreeID(
CONST INT iID //(I)ID >0
)
{
	struct ID_INFO *ps_IDTmp = NULL, *ps_IDPrev = NULL;
#ifdef WIN32
	HANDLE hMtx = CreateMutex( NULL, FALSE, TSCSV_MUTEX );
	WaitForSingleObject( hMtx, INFINITE ); //å
#endif //WIN32
	ps_IDTmp = GetIDInfo( iID, &ps_IDPrev );
	if ( !ps_IDTmp ) //IDĤʤä
	{
#ifdef WIN32
		ReleaseMutex( hMtx ); //ߥ塼ƥå
#endif //WIN32
		return -1;
	}
	ps_IDPrev->ps_IDNext = ps_IDTmp->ps_IDNext; //ꥹȤĤʤľ
	free( ps_IDTmp->pszDlmt );
	free( ps_IDTmp->pszQuot );
	free( ps_IDTmp->pszEsc );
	free( ps_IDTmp );
#ifdef WIN32
	ReleaseMutex( hMtx ); //ߥ塼ƥå
#endif //WIN32
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽեɤʸȤƼ롣
//⡧ʸե˴ޤޤȤˤϡ
//      ɬեΤ⥨ʸǰϤޤƤ뤳ȡ
//      㡥
//        桼ϡš|abc",ABC|"xyz"|LM"N|    EXCEL97 ˤƼ¸
//        CSV ššššš"abc"",ABC","""xyz""","LM""N"
//1ԥɤϻ˺ƤΤǹθʤƤ褤
//2ХʸθƬ鸡롣
//3ReadMe.txt򻲾ȡ
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2001/11/01 
//          V1.1.0 2001/11/14 
//                   顼ɤ硣
//                   ʸľΣХȥɤб
//                   char*  unsigned char* ѹ
//                   long  unsigned long ѹ
//                   calloc()  alloca() ѹ
//          V1.2.0 2001/12/24 
//                   TSCSV_SAME_CLASS б
//                   unsigned char*  char* ѹ
//                   TSLB_IsLeadByte()  ISMBSLEAD(),ISMBSTRAIL() ѹ
//          V1.3.0 2001/12/30 
//                   ʸνְ㤨ƤΤǽ
//          V1.4.0 2002/01/15 
//                   եɤԤˤޤǽȤб
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_GetFieldAsString(
CONST INT iID, //(I)ID >0
LPCTSTR pszLine, //(I)ʸ˲ԥɤäƤ褤
CONST DWORD dwFldIdx, //(I)Фեɥǥå >=0
LPTSTR pszFld, //(O)եʸ
CONST DWORD dwFldLen //(I)pszFld ΥХåե
)
{
	BOOL bFnd = FALSE; //ȯե饰
	DWORD dwQuotCnt = 0, dwFldCnt = 0;
	DWORD dwDlmtLen = 0, dwQuotLen = 0, dwEscLen = 0;
	LPTSTR pszFldTmp = NULL;
	LPTSTR pszTop = NULL, pszNext = NULL;
	LPTSTR pszQuot = NULL, pszEsc = NULL, pszEscOld = NULL;
	struct ID_INFO *ps_ID = NULL;

//ѥ᡼å
	ps_ID = GetIDInfo( iID, NULL ); //ID
	if ( !ps_ID ) //IDĤʤʤ
		return -1;
	if ( !pszLine || !pszFld ) //ݥ󥿤ʤ
	{
		ps_ID->iErrNo = ERRNO_4105;
		return -1;
	}
//
	memset( pszFld, 0, dwFldLen ); //
	pszFldTmp = (LPTSTR)alloca( strlen( pszLine )+1 ); //ΰ
#ifdef _DEBUG
	memset((LPBYTE)pszFldTmp, 'A', strlen( pszLine )+1 );
#endif
	dwDlmtLen = strlen( ps_ID->pszDlmt );
	dwQuotLen = strlen( ps_ID->pszQuot );
	dwEscLen = strlen( ps_ID->pszEsc );
//ᥤ
	pszTop = (LPTSTR)pszLine; //Ƭ
	pszNext = pszTop; //󸡺
	while ( 1 )
	{
		LPTSTR pszDlmt = MBSSTR( pszNext, ps_ID->pszDlmt ); //֤߰ǽΥǥߥ򸡺
		if ( dwQuotLen ) //ʸꤵƤ
		{
			pszQuot = pszNext; //Υݥ
			while ( 1 ) //ǥߥޤǤγʸο
			{
				pszQuot = MBSSTR( pszQuot, ps_ID->pszQuot );
				if ( !pszQuot || ( pszQuot >= pszDlmt && pszDlmt )) //ƿä
					break;
				dwQuotCnt++;
				pszQuot += dwQuotLen; //ȯʸμƸ
			}
		}
		if ( dwQuotCnt%2 ) //ʸʤ
		{
			if ( !pszDlmt ) //ǥߥ̵ʤäʺǸΥեɤʤ
			{
				ps_ID->iErrNo = ERRNO_4119; //Ԥˤޤǽ
				return -1;
			}
			pszNext = pszDlmt + dwDlmtLen; //ǡΥǥߥʤΤǥå
			continue;
		}
		if ( !pszDlmt ) //ǥߥ̵ʤä
		{
			if ( dwFldIdx == dwFldCnt ) //եɤʤ
			{
				strcpy( pszFldTmp, pszNext ); //ΰ˥ԡ
				if ( pszFldTmp[strlen( pszFldTmp )-1] == '\n' ) //ԥɤʤ
					pszFldTmp[strlen( pszFldTmp )-1] = '\0'; //
				bFnd = TRUE; //ȯ
			}
			break;
		}
		//3 ʸĤʤơʸȥʸۤʤʸʤ
		if ( !dwQuotCnt && strcmp( ps_ID->pszQuot, ps_ID->pszEsc ) && dwEscLen )
		{
			pszEsc = pszNext; //Υݥ
			pszEscOld = NULL;
			while ( 1 ) //2 ǥߥľʸĴ٤
			{
				pszEsc = MBSSTR( pszEsc, ps_ID->pszEsc );
				if ( !pszEsc || pszEsc >= pszDlmt ) //ƿä
					break;
				pszEscOld = pszEsc;
				pszEsc += dwEscLen + 1; //ȯʸμμƸ
			}
			if ( pszEscOld ) //ǸΥʸ
			{
				//ʸμǥߥʤ
				if ( pszEscOld + dwEscLen == pszDlmt )
				{
					pszNext = pszDlmt + dwDlmtLen; //ǡΥǥߥʤΤǥå
					continue;
				}
			}
		}
		if ( dwFldIdx == dwFldCnt ) //եɤʤ
		{
			DWORD dwLen = strlen( pszTop ) - strlen( pszDlmt ); //ԡĹ
			strncpy( pszFldTmp, pszTop, dwLen );
			pszFldTmp[dwLen] = '\0'; //NULL ȥå
			bFnd = TRUE; //ȯ
			break;
		}
		if ( ps_ID->dwOpt & TSCSV_SAME_CLASS ) //Ϣ³ǥߥñΤȸʤʤ
		{
			while ( strlen( pszDlmt ) >= dwDlmtLen ) //˽ʬĹ뤳Ȥǧ
			{
				if ( strncmp( pszDlmt, ps_ID->pszDlmt, dwDlmtLen )) //ǥߥϢ³Ƥʤʤ
					break;
				pszDlmt += dwDlmtLen; //å
			}
			pszDlmt--; //Ϣ³ǥߥκǸΥǥߥ֤᤹
		}
		pszTop = pszNext = pszDlmt + dwDlmtLen; //ǥߥμƸ
		dwFldCnt++; //եɿ
		dwQuotCnt = 0; //ꥻå
	}
	if ( !bFnd ) //ŪΥեɤʤä
	{
		ps_ID->iErrNo = ERRNO_4104;
		return -1;
	}
	//ʸȥʸ
	if ( dwQuotLen ) //ʸꤵƤ
	{
		//Ƭʸʤ
		if ( !strncmp( pszFldTmp, ps_ID->pszQuot, dwQuotLen ))
		{
			//1 ǰΤΤ
			if ( !strcmp( &pszFldTmp[strlen( pszFldTmp )-dwQuotLen], ps_ID->pszQuot ))
				pszFldTmp[strlen( pszFldTmp )-dwQuotLen] = '\0'; //
			//Ƭ
			memmove( pszFldTmp, pszFldTmp+dwQuotLen, strlen( pszFldTmp+dwQuotLen )+1 );
		}
	}
	if ( dwEscLen ) //ʸꤵƤ
	{
		pszNext = pszFldTmp;
		while ( 1 ) //եΥʸ
		{
			pszEsc = MBSSTR( pszNext, ps_ID->pszEsc ); //ʸõ
			if ( !pszEsc )
				break;
			memmove((LPBYTE)pszEsc, pszEsc+dwEscLen, strlen( pszEsc+dwEscLen )+1 );
			if ( strlen( pszEsc ) <= 1 ) //ǰΤstrlen(pszEsc)==0 ϤʤϤ
				pszNext = pszEsc+1;
			else
				//ʸľ夬Хʸɤˤäƥå׿Ĵ
				pszNext = ( !ISMBSLEAD( pszEsc, pszEsc )) ? pszEsc+1 : pszEsc+2;
		}
	}
	if ( strlen( pszFldTmp ) >= dwFldLen ) //Хåե˼ޤ꤭ʤʤ
	{
		ps_ID->iErrNo = ERRNO_4110;
		return -1;
	}
	strcpy( pszFld, pszFldTmp );
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽեɿ롣
//ֵ͡>=0:եɿ  <0:顼
//СV1.0.0 2001/11/03 
//          V1.1.0 2001/11/19 
//                   char*  unsigned char* ѹ
//                   calloc()  alloca() ѹ
//          V1.2.0 2001/12/24 
//                   unsigned char*  char* ѹ
//          V1.3.1 2002/01/13 
//                   ʸ󤬶ʸΤȤֵ =0 Ȥ롣
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_GetFieldCount(
CONST INT iID, //(I)ID >0
LPCTSTR pszLine //(I)ʸ
)
{
	DWORD dwIdx = 0;
	LPTSTR pszFldTmp = NULL;
	struct ID_INFO *ps_ID = NULL;

	ps_ID = GetIDInfo( iID, NULL ); //ID
	if ( !ps_ID ) //IDĤʤʤ
		return -1;
//ѥ᡼å
	if ( !pszLine )
	{
		ps_ID->iErrNo = ERRNO_4109;
		return -1;
	}
//ᥤ
	if ( strlen( pszLine )) //ʸǤʤʤ
	{
		pszFldTmp = (LPTSTR)alloca( strlen( pszLine )+1 );
#ifdef _DEBUG
		memset( pszFldTmp, 'A', strlen( pszLine )+1 );
#endif
		while ( 1 )
		{
			//˳ƥեɤƤߤ
			if ( TSCSV_GetFieldAsString( iID, pszLine, dwIdx, pszFldTmp, strlen( pszLine )+1 ) < 0 )
			{
				if ( ps_ID->iErrNo == ERRNO_4104 ) //եɤʤʤ
					break; //Ǥʤä齪λ
				return -1;
			}
			dwIdx++;
		}
	}
	return (INT)dwIdx;
}

///////////////////////////////////////////////////////////////////////////////
//ǽǥߥ򥻥åȤ롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2001/11/03 
//          V1.1.0 2001/11/19 
//                   char*  unsigned char* ѹ
//          V1.2.0 2001/12/24 
//                   unsigned char*  char* ѹ
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_SetDelimiter(
CONST INT iID,
LPCTSTR pszDlmt
)
{
	struct ID_INFO *ps_ID = NULL;

	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return -1;
	if ( !pszDlmt )
	{
		ps_ID->iErrNo = ERRNO_4111;
		return -1;
	}
	if ( !strlen( pszDlmt ))
	{
		ps_ID->iErrNo = ERRNO_4112;
		return -1;
	}
	free( ps_ID->pszDlmt );
	ps_ID->pszDlmt = strdup( pszDlmt );
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽ국򥻥åȤ롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2001/11/03 
//          V1.1.0 2001/11/19 
//                   char*  unsigned char* ѹ
//                   pszQuot==NULL ϶ʸȸʤ
//          V1.2.0 2001/12/24 
//                   unsigned char*  char* ѹ
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_SetQuot(
CONST INT iID,
LPCTSTR pszQuot
)
{
	struct ID_INFO *ps_ID = NULL;

	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return -1;
	if ( !pszQuot )
		pszQuot = "";
	free( ps_ID->pszQuot );
	ps_ID->pszQuot = strdup( pszQuot );
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽʸ򥻥åȤ롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.0.0 2001/11/03 
//          V1.1.0 2001/11/14 
//                   char*  unsigned char* ѹ
//          V1.2.0 2001/12/24 
//                   unsigned char*  char* ѹ
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_SetEscape(
CONST INT iID,
LPCTSTR pszEsc
)
{
	struct ID_INFO *ps_ID = NULL;

	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return -1;
	if ( !pszEsc )
	{
		ps_ID->iErrNo = ERRNO_4114;
		return -1;
	}
	free( ps_ID->pszEsc );
	ps_ID->pszEsc = strdup( pszEsc );
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽ顼ɤ֤
//ֵ͡>0:顼  <0:顼
//СV1.0.0 2001/11/03 
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_GetErrorNo(
CONST INT iID //(I)ID >0
)
{
	struct ID_INFO *ps_ID = NULL;

	if ( iID <= 0 )
		return miErrNo;
	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return miErrNo;
	return ps_ID->iErrNo;
}

///////////////////////////////////////////////////////////////////////////////
//ǽCSV ʸ롣
//⡧ʸ != NULL ΤȤšŰŪ CSV 
//      ʸ  = NULL ΤȤšTSCSV γĥ
//12ERRNO_4116 ǰäƤΤǥСեϤʤϤ
//ֵ͡=0:ｪλ  <0:顼
//СV1.1.0 2001/11/14 
//          V1.2.0 2001/12/24 
//                   unsigned char*  char* ѹ
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_CreateLine(
CONST INT iID, //(I)ID >0
CONST DWORD dwFldIdx, //(I)եɥǥå >=0
LPCTSTR pszFld, //(I)եʸ
LPTSTR pszLine, //(O)ʸ
CONST DWORD dwLineLen //(I)pszLine ΥХåե
)
{
	struct ID_INFO *ps_ID = NULL;
	LPTSTR pszLineTmp = NULL, pszFldTmp = NULL;
	LPTSTR pszNext = NULL, pszTrgt = NULL;
	LPTSTR pszTrgtPtr = NULL, pszEscPtr = NULL;
	DWORD dwQuotLen = 0, dwEscLen = 0, dwCopyLen = 0;

	ps_ID = GetIDInfo( iID, NULL );
	if ( !ps_ID )
		return -1;
//ѥ᡼å
	if ( dwLineLen < strlen( pszFld ) + 1 )
	{
		ps_ID->iErrNo = ERRNO_4116;
		return -1;
	}
	if ( !pszFld || !pszLine )
	{
		ps_ID->iErrNo = ERRNO_4107;
		return -1;
	}
//ᥤ
	dwQuotLen = strlen( ps_ID->pszQuot );
	dwEscLen = strlen( ps_ID->pszEsc );
	pszLineTmp = (LPTSTR)alloca( dwLineLen );
	memset( pszLineTmp, 0, dwLineLen );
	pszFldTmp = (LPTSTR)alloca( dwLineLen );
	memset( pszFldTmp, 0, dwLineLen );
	if ( !dwFldIdx ) //Ƭʤ
		memset( pszLine, 0, dwLineLen ); //
	else //ܰʹߤʤ
		strcat( pszLineTmp, ps_ID->pszDlmt ); //ǥߥղ
	strcat( pszLineTmp, ps_ID->pszQuot ); //Ϥ
	pszNext = (LPTSTR)pszFld;
	while ( 1 )
	{
		if ( dwQuotLen ) //ʸꤵƤ
		{
			pszTrgtPtr = MBSSTR( pszNext, ps_ID->pszQuot ); //եγʸõ
			pszTrgt = ps_ID->pszQuot;
		}
		else //ʸꤵƤʤä
		{
			pszTrgtPtr = MBSSTR( pszNext, ps_ID->pszDlmt ); //եΥǥߥõ
			pszTrgt = ps_ID->pszDlmt;
			if ( pszTrgtPtr && !dwEscLen ) //ʸꤵƤʤΤ˥ǥߥä
			{	//顼
				ps_ID->iErrNo = ERRNO_4102;
				return -1;
			}
			if ( dwEscLen ) //ʸꤵƤ
			{
				pszEscPtr = MBSSTR( pszNext, ps_ID->pszEsc ); //եΥפõ
				//ʸ˸Ĥä
				if (( pszEscPtr && pszEscPtr < pszTrgtPtr ) || !pszTrgtPtr )
				{
					pszTrgtPtr = pszEscPtr;
					pszTrgt = ps_ID->pszEsc;
				}
			}
		}
		if ( !pszTrgtPtr )
			break;
		dwCopyLen = pszTrgtPtr - pszNext;
		strncpy( pszFldTmp, pszNext, dwCopyLen ); //1
		pszFldTmp[dwCopyLen] = '\0'; //NULL ȥå

		if ( strlen( pszLineTmp ) + strlen( pszFldTmp ) + dwEscLen + strlen( pszTrgt ) + 1 > dwLineLen )
		{	//顼
			ps_ID->iErrNo = ERRNO_4117;
			return -1;
		}
		strcat( pszLineTmp, pszFldTmp ); 
		strcat( pszLineTmp, ps_ID->pszEsc );
		strcat( pszLineTmp, pszTrgt );

		pszNext = pszTrgtPtr + strlen( pszTrgt );
	}
	if ( strlen( pszLineTmp ) + strlen( pszNext ) + 1 > dwLineLen )
	{	//顼
		ps_ID->iErrNo = ERRNO_4115;
		return -1;
	}
	strcat( pszLineTmp, pszNext ); //Ĥ
	strcat( pszLineTmp, ps_ID->pszQuot ); //꽪

	if ( strlen( pszLine ) + strlen( pszLineTmp ) + 1 > dwLineLen )
	{	//顼
		ps_ID->iErrNo = ERRNO_4118;
		return -1;
	}
	strcat( pszLine, pszLineTmp );

	return 0;
}

///////////////////////////////////////////////////////////////////////////////
//ǽץ򥻥åȤ롣
//ֵ͡=0:ｪλ  <0:顼
//СV1.2.0 2001/12/04 
///////////////////////////////////////////////////////////////////////////////
INT WINAPI TSCSV_SetOption(
CONST INT iID, //(I)ID >0
CONST DWORD dwOpt, //(I)ץ
CONST LONG lData //(I)ץ
)
{
	struct ID_INFO *ps_ID = NULL;

	ps_ID = GetIDInfo( iID, NULL ); //ID 
	if ( !ps_ID )
		return -1;
	if ( dwOpt & TSCSV_DELETE ) //ץʤ
		ps_ID->dwOpt &= ~dwOpt;
	else
		ps_ID->dwOpt |= dwOpt;
	return 0;
}
