///////////////////////////////////////////////////////////////////////////////
//ǽCSV եʸʬ򤹤롣
//⡧Windows,UNIX ǥͭ
//СV1.0.0 2001/11/03 
//          V1.1.0 2001/11/14 
//          V1.2.0 2001/12/24 
//          V1.4.0 2002/01/15 
//Copyright (C) 2001-2002 Takashi Sugiyama. All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
#ifndef TSCSV_H_2001_11_01_22_49
#define TSCSV_H_2001_11_01_22_49

#ifdef WIN32
	#include <windows.h>
#endif

#ifdef WIN32
	#define DLL_EXPORT __declspec(dllexport)
#else //UNIX
	#define DLL_EXPORT extern
	#define WINAPI //̵

	#ifndef CONST
		#define CONST const
		#define TSCSV_DEFINE_CONST
	#endif
	#ifndef VOID
		#define VOID void
		#define TSCSV_DEFINE_VOID
	#endif
	#ifndef BOOL
		#define BOOL int
		#define TSCSV_DEFINE_BOOL
	#endif
	#ifndef INT
		#define INT int
		#define TSCSV_DEFINE_INT
	#endif
	#ifndef LONG
		#define LONG long
		#define TSCSV_DEFINE_LONG
	#endif
	#ifndef DWORD
		#define DWORD unsigned long
		#define TSCSV_DEFINE_DWORD
	#endif
	#ifndef LPTSTR
		#define LPTSTR char*
		#define TSCSV_DEFINE_LPTSTR
	#endif
	#ifndef LPCTSTR
		#define LPCTSTR const char*
		#define TSCSV_DEFINE_LPCTSTR
	#endif
	#ifndef TRUE
		#define TRUE 1
		#define TSCSV_DEFINE_TRUE
	#endif
	#ifndef FALSE
		#define FALSE 0
		#define TSCSV_DEFINE_FALSE
	#endif
#endif

#ifdef TSCSV_LOCAL
	#define TSCSV_GetID LOCAL_TSCSV_GetID
	#define TSCSV_FreeID LOCAL_TSCSV_FreeID
	#define TSCSV_GetFieldAsString LOCAL_TSCSV_GetFieldAsString
	#define TSCSV_GetFieldCount LOCAL_TSCSV_GetFieldCount
	#define TSCSV_SetDelimiter LOCAL_TSCSV_SetDelimiter
	#define TSCSV_SetQuot LOCAL_TSCSV_SetQuot
	#define TSCSV_SetEscape LOCAL_TSCSV_SetEscape
	#define TSCSV_GetErrorNo LOCAL_TSCSV_GetErrorNo
	#define TSCSV_CreateLine LOCAL_TSCSV_CreateLine
	#define TSCSV_SetOption LOCAL_TSCSV_SetOption
#endif

#ifdef __cplusplus
	extern "C" {
#endif

DLL_EXPORT INT WINAPI TSCSV_GetID( VOID );
DLL_EXPORT INT WINAPI TSCSV_FreeID( CONST INT iID );
DLL_EXPORT INT WINAPI TSCSV_GetFieldAsString( CONST INT iID, LPCTSTR pszLine, CONST DWORD dwFldIdx, LPTSTR pszFld, CONST DWORD dwFldLen );
DLL_EXPORT INT WINAPI TSCSV_GetFieldCount( CONST INT iID, LPCTSTR pszLine );
DLL_EXPORT INT WINAPI TSCSV_SetDelimiter( CONST INT iID, LPCTSTR pszDlmt );
DLL_EXPORT INT WINAPI TSCSV_SetQuot( CONST INT iID, LPCTSTR pszQuot );
DLL_EXPORT INT WINAPI TSCSV_SetEscape( CONST INT iID, LPCTSTR pszEsc );
DLL_EXPORT INT WINAPI TSCSV_GetErrorNo( CONST INT iID );
DLL_EXPORT INT WINAPI TSCSV_CreateLine( CONST INT iID, CONST DWORD dwFldIdx, LPCTSTR pszFld, LPTSTR pszLine, CONST DWORD dwLineLen );
DLL_EXPORT INT WINAPI TSCSV_SetOption( CONST INT iID, CONST DWORD dwOpt, CONST LONG lData );

#ifdef __cplusplus
	}
#endif

#ifdef TSCSV_DEFINE_CONST
	#undef CONST
#endif
#ifdef TSCSV_DEFINE_VOID
	#undef VOID
#endif
#ifdef TSCSV_DEFINE_BOOL
	#undef BOOL
#endif
#ifdef TSCSV_DEFINE_INT
	#undef INT
#endif
#ifdef TSCSV_DEFINE_LONG
	#undef LONG
#endif
#ifdef TSCSV_DEFINE_DWORD
	#undef DWORD
#endif
#ifdef TSCSV_DEFINE_LPTSTR
	#undef LPTSTR
#endif
#ifdef TSCSV_DEFINE_LPCTSTR
	#undef LPCTSTR
#endif
#ifdef TSCSV_DEFINE_TRUE
	#undef TRUE
#endif
#ifdef TSCSV_DEFINE_FALSE
	#undef FALSE
#endif

//ץ
#define TSCSV_DELETE		0x80000000 //ץ
#define TSCSV_SAME_CLASS	0x00000001 //Ϣ³ǥߥñΤȤߤʤ

#endif //TSCSV_H_2001_11_01_22_49
