///////////////////////////////////////////////////////////////////////////////
//ǽTSLog Υޥեġ롣
//Copyright (C) 2002 Takashi Sugiyama. All rights reserved.
///////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h> //strtol()
#include <string.h> //strcasecmp()
#include <sys/types.h> //semget()
#include <sys/ipc.h> //semget()
#include <sys/sem.h> //semget()

///////////////////////////////////////////////////////////////////////////////
//ǽᥤ
//СV1.0.0 2002/01/26 
///////////////////////////////////////////////////////////////////////////////

#define USAGE "Usage: tslogsem semkey [c(heck)|d(elete)|m(ake)|r(eset)]"
#define EXIST "Semkey %d(0x%08x) already exists.\n"
#define NOT_EXIST "Semkey %d(0x%08x) does not exist.\n"

int main(
int argc,
char *argv[] //[1]:ޥե  [2]:ޥ
)
{
	int iSemKey, iSemID, iRet;

	if ( argc != 3 )
	{
		puts( USAGE );
		return 0;
	}
//ᥤ
	iSemKey = strtol( argv[1], NULL, 0 );
	if ( !iSemKey )
	{
		puts( USAGE );
		return 0;
	}
	if ( !strcasecmp( argv[2], "check" ) || ( !argv[2][1] && !strncasecmp( argv[2], "c", 1 )))
	{
		iSemID = semget( iSemKey, 1, IPC_CREAT|IPC_EXCL|0666 );
		if ( iSemID == -1 ) //¸ߤƤ
		{
			iSemID = semget( iSemKey, 1, IPC_CREAT|0666 ); //å
			if ( iSemID == -1 )
			{
				perror( "semget() ERROR: " );
				return 1;
			}
			iRet = semctl( iSemID, 0, GETVAL, NULL ); //ͤ
			printf( EXIST, iSemKey, iSemKey );
			if ( !iRet )
				puts( "Semaphore's value is 0. Logfile is locked." );
			else if ( iRet == 1 )
				puts( "Semaphore's value is 1. Logfile is not locked." );
			else
			{
				printf( "Semaphore's value is %d. It is abnormal.\n", iRet );
				printf( "Use 'reset' command. ( tslogsem semkey reset )\n" );
			}
		}
		else //¸ߤƤʤʤ
		{
			semctl( iSemID, 0, IPC_RMID, NULL ); //äƤޤäΤǺ
			printf( NOT_EXIST, iSemKey, iSemKey );
		}
	}
	else if ( !strcasecmp( argv[2], "delete" ) || ( !argv[2][1] && !strncasecmp( argv[2], "d", 1 )))
	{
		iSemID = semget( iSemKey, 1, IPC_CREAT|IPC_EXCL|0666 );
		if ( iSemID == -1 ) //¸ߤƤ
		{
			iSemID = semget( iSemKey, 1, IPC_CREAT|0666 ); //å
			if ( iSemID == -1 )
			{
				perror( "semget() ERROR: " );
				return 1;
			}
			if ( semctl( iSemID, 0, IPC_RMID, NULL ) == -1 ) //
			{
				perror( "semctl(IPC_RMID) ERROR: " );
				return 1;
			}
			printf( "Semkey %d(%#x) is deleted.\n", iSemKey, iSemKey );
		}
		else //¸ߤƤʤʤ
		{
			semctl( iSemID, 0, IPC_RMID, NULL ); //äƤޤäΤǺ
			printf( NOT_EXIST, iSemKey, iSemKey );
		}
	}
	else if ( !strcasecmp( argv[2], "make" ) || ( !argv[2][1] && !strncasecmp( argv[2], "m", 1 )))
	{
		iSemID = semget( iSemKey, 1, IPC_CREAT|IPC_EXCL|0666 );
		if ( iSemID == -1 ) //¸ߤƤ
			printf( EXIST, iSemKey, iSemKey );
		else //¸ߤƤʤʤ
			printf( "Semkey %d(%#x) is created.\n", iSemKey, iSemKey );
	}
	else if ( !strcasecmp( argv[2], "reset" ) || ( !argv[2][1] && !strncasecmp( argv[2], "r", 1 )))
	{
		iSemID = semget( iSemKey, 1, IPC_CREAT|IPC_EXCL|0666 );
		if ( iSemID == -1 ) //¸ߤƤ
		{
			iSemID = semget( iSemKey, 1, IPC_CREAT|0666 ); //å
			if ( iSemID == -1 )
			{
				perror( "semget() ERROR: " );
				return 1;
			}
			if ( semctl( iSemID, 0, SETVAL, 1 ) == -1 ) //ˤ
			{
				perror( "semctl(SETVAL) ERROR: " );
				return 1;
			}
			puts( "Semaphore's value is set as 1. Logfile is not locked." );
		}
		else
		{
			semctl( iSemID, 0, IPC_RMID, NULL ); //äƤޤäΤǺ
			printf( NOT_EXIST, iSemKey, iSemKey );
		}
	}
	else
	{
		puts( USAGE );
		return 0;
	}
	return 0;
}

