///////////////////////////////////////////////////////////////////////////////
//ǽå˥Ϥ롣
//⡧Windows,UNIX ǥͭ
//Copyright (C) 2001-2002 Takashi Sugiyama. All rights reserved.
///////////////////////////////////////////////////////////////////////////////
#ifndef TSLOG_H_2001_11_11_13_52
#define TSLOG_H_2001_11_11_13_52

#ifdef WIN32
	#include <windows.h>
#endif

#ifdef WIN32
	#define DLL_EXPORT __declspec(dllexport)
#else
	#define DLL_EXPORT extern
	#define WINAPI //̵

	#ifndef CONST
		#define CONST const
		#define TSLOG_DEFINE_CONST
	#endif
	#ifndef VOID
		#define VOID void
		#define TSLOG_DEFINE_VOID
	#endif
	#ifndef LPVOID
		#define LPVOID void*
		#define TSLOG_DEFINE_LPVOID
	#endif
	#ifndef LPBYTE
		#define LPBYTE unsigned char*
		#define TSLOG_DEFINE_LPBYTE
	#endif
	#ifndef BOOL
		#define BOOL int
		#define TSLOG_DEFINE_BOOL
	#endif
	#ifndef INT
		#define INT int
		#define TSLOG_DEFINE_INT
	#endif
	#ifndef LONG
		#define LONG long
		#define TSLOG_DEFINE_LONG
	#endif
	#ifndef DWORD
		#define DWORD unsigned long
		#define TSLOG_DEFINE_DWORD
	#endif
	#ifndef LPTSTR
		#define LPTSTR char*
		#define TSLOG_DEFINE_LPTSTR
	#endif
	#ifndef LPCTSTR
		#define LPCTSTR const char*
		#define TSLOG_DEFINE_LPCTSTR
	#endif
	#ifndef TRUE
		#define TRUE 1
		#define TSLOG_DEFINE_TRUE
	#endif
	#ifndef FALSE
		#define FALSE 0
		#define TSLOG_DEFINE_FALSE
	#endif
#endif

#ifndef TSLOG_STATIC
	#define TSLOG_STATIC //̵
#endif

#ifdef __cplusplus
	extern "C" {
#endif

TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_GetID( VOID );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_FreeID( CONST INT iID );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_Init( CONST INT iID, LPCTSTR pszDir, CONST INT iSemKey );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_Write( CONST INT iID, LPCTSTR pszLog, ... );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_Write2( CONST INT iID, LPCTSTR pszLog, ... );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_Write3( CONST INT iID, LPCTSTR pszLog, ... );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_WriteHex( CONST INT iID, CONST LPVOID pvData, CONST DWORD dwDataLen, LPCTSTR pszMsg, ... );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_WriteVB( CONST INT iID, LPCTSTR pszLog );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_WriteVB2( CONST INT iID, LPCTSTR pszLog );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_WriteVB3( CONST INT iID, LPCTSTR pszLog );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_WriteHexVB( CONST INT iID, CONST LPVOID pvData, CONST DWORD dwDataLen, LPCTSTR pszMsg );
TSLOG_STATIC DLL_EXPORT INT WINAPI TSLOG_GetErrorNo( CONST INT iID );

#ifdef __cplusplus
	};
#endif

#ifdef TSLOG_DEFINE_CONST
	#undef CONST
#endif
#ifdef TSLOG_DEFINE_VOID
	#undef VOID
#endif
#ifdef TSLOG_DEFINE_LPVOID
	#undef LPVOID
#endif
#ifdef TSLOG_DEFINE_LPBYTE
	#undef LPBYTE
#endif
#ifdef TSLOG_DEFINE_BOOL
	#undef BOOL
#endif
#ifdef TSLOG_DEFINE_INT
	#undef INT
#endif
#ifdef TSLOG_DEFINE_LONG
	#undef LONG
#endif
#ifdef TSLOG_DEFINE_DWORD
	#undef DWORD
#endif
#ifdef TSLOG_DEFINE_LPTSTR
	#undef LPTSTR
#endif
#ifdef TSLOG_DEFINE_LPCTSTR
	#undef LPCTSTR
#endif
#ifdef TSLOG_DEFINE_TRUE
	#undef TRUE
#endif
#ifdef TSLOG_DEFINE_FALSE
	#undef FALSE
#endif

#endif //TSLOG_H_2001_11_11_13_52
